﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using OpenTK;
using OpenTK.Graphics.OpenGL;

//using System.Drawing;

namespace OpenTK_Test
{
	class Game : GameWindow
	{
		//int texture;
		Texture2D texture;

		View view;


		public Game(int width, int height)
			: base(width, height)
		{
			GL.Enable(EnableCap.Texture2D);

			this.view = new View(Vector2.Zero, 1.0, 0.0);
			//this.view = new View(Vector2.Zero, 2.0, MathHelper.PiOver4);

			Mouse.ButtonDown += Mouse_ButtonDown;
		}

		void Mouse_ButtonDown(object sender, OpenTK.Input.MouseButtonEventArgs e)
		{
			Vector2 pos = new Vector2(e.Position.X, e.Position.Y);
			pos -= new Vector2(this.Width, this.Height) / 2f;
			pos = view.ToWorld(pos);

			view.SetPosition(pos, TweenType.QuadraticInOut, 60);
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			this.texture = ContentPipe.LoadTexture("supwergirl.jpg");
		}

		protected override void OnUpdateFrame(FrameEventArgs e)
		{
			base.OnUpdateFrame(e);

			//view.position.Y += 0.01f;

			view.Update();
		}

		protected override void OnRenderFrame(FrameEventArgs e)
		{
			base.OnRenderFrame(e);

			GL.Clear(ClearBufferMask.ColorBufferBit);
			GL.ClearColor(Color.CornflowerBlue);

			Spritebatch.Begin(this.Width, this.Height);
			view.ApplyTransform();

			Spritebatch.Draw(texture
								, Vector2.Zero
								, new Vector2(0.2f, 0.2f)
								, Color.Green
								, new Vector2(10, 50));

			Spritebatch.Draw(texture
								, new Vector2(100, 10)
								, new Vector2(0.2f, 0.2f)
								, Color.Red
								, new Vector2(10, 50));
			
			Spritebatch.Draw(texture
								, new Vector2(200, 20)
								, new Vector2(0.2f, 0.2f)
								, Color.Blue
								, new Vector2(10, 50));
			
			Spritebatch.Draw(texture
								, new Vector2(300, 30)
								, new Vector2(0.2f, 0.2f)
								, Color.Yellow
								, new Vector2(10, 50));

			this.SwapBuffers();
		}

	}
}
