﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using OpenTK;
using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;
using OpenTK_Test;

namespace OpenTK_Winform
{
	class claGLFormDisplay
	{
		/// <summary>
		/// 화면으로 사용할 컨트롤
		/// </summary>
		public GLControl Screen { get; private set; }

		/// <summary>
		/// 카메라 역할을 할 뷰
		/// </summary>
		//private View view;
		public View view;


		/// <summary>
		/// 
		/// </summary>
		private Texture2D texture;


		public claGLFormDisplay(GLControl glScreen)
		{
			this.Setup(glScreen);
		}

		/// <summary>
		/// GL 출력 준비를 합니다.
		/// </summary>
		/// <param name="glScreen"></param>
		public void Setup(GLControl glScreen)
		{
			//화면으로 사용할 컨트롤 저장
			this.Screen = glScreen;
			//이벤트 연결
			this.Screen.Paint += Screen_Paint;
			this.Screen.Resize += Screen_Resize;

			//2D 텍스처 사용알림
			GL.Enable(EnableCap.Texture2D);

			//뷰초기화
			this.view = new View(Vector2.Zero, 1.0, 0.0);
			//this.m_glView = new View(new Vector2(glScreen.Width / 2, glScreen.Height / 2), 1.0, 0.0);
			//this.m_glView.SetPosition(new Vector2(300, 0));

			//텍스쳐 불러오기
			this.LoadTexture();
		}

		public void LoadTexture()
		{
			this.texture = ContentPipe.LoadTexture("supwergirl.jpg");
		}

		/// <summary>
		/// Render에서 그린 이미지를 출력 합니다.
		/// </summary>
		void Screen_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			view.Update();

			//this.Screen.MakeCurrent();

			//GL.Clear(ClearBufferMask.ColorBufferBit);
			GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);
			GL.ClearColor(Color.SkyBlue);
			
			
			Spritebatch.Begin(this.Screen.Width, this.Screen.Height);
			view.ApplyTransform();

			//내용 그리기
			this.Render();

			this.Screen.SwapBuffers();
		}

		void Screen_Resize(object sender, EventArgs e)
		{
			//뷰포트 초기화
			//this.SetupViewport();
			
			view.SetPosition(new Vector2((this.Screen.Width / 2), 0));
			//view.SetPosition(new Vector2(0, this.Screen.Height));
			
			GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);
			this.Screen.SwapBuffers();

			/*
			this.Screen.MakeCurrent();
			//GL.MatrixMode(MatrixMode.Projection);
			GL.LoadIdentity();
			GL.Ortho(...);*/
		}

		/// <summary>
		/// 뷰포트설정을 바꾼다.
		/// </summary>
		private void SetupViewport()
		{/*
			int w = this.Screen.Width;
			int h = this.Screen.Height;
			GL.MatrixMode(MatrixMode.Projection);
			GL.LoadIdentity();
			GL.Ortho(0, w, 0, h, -1, 1); // Bottom-left corner pixel has coordinate (0, 0)
			GL.Viewport(0, 0, w, h); // Use all of the glControl painting area
			*/
		}

		public void Render()
		{
			//GL.Color3(Color.Empty);

			GL.End();
			//GL.Color3(Color.Yellow);

			GL.Rect(0, 0, this.Screen.Width, this.Screen.Height); 
			GL.End();

			GL.Rect(20, 20, 100, 100);
			GL.End();
			/*Spritebatch.Draw(texture
								, Vector2.Zero
								, new Vector2(0.2f, 0.2f)
								, Color.Green
								, new Vector2(10, 50));*/

			Spritebatch.Draw(texture
								, new Vector2(100, 10)
								, new Vector2(0.2f, 0.2f)
								, Color.Empty
								, new Vector2(10, 50));

			Spritebatch.Draw(texture
								, new Vector2(200, 20)
								, new Vector2(0.2f, 0.2f)
								, Color.Blue
								, new Vector2(10, 50));

			Spritebatch.Draw(texture
								, new Vector2(300, 30)
								, new Vector2(0.2f, 0.2f)
								, Color.Yellow
								, new Vector2(10, 50));

			

		}



	}
}
